<?php

require_once( 'class.focussitecalllite-credentials.php' );
require_once( 'class.focussitecalllite-sitecalls-model.php' );

require_once( 'class.focussitecalllite-templates-sitecalls-list-table.php' );
require_once( 'class.focussitecalllite-sitecalls-list-table.php' );

require_once( 'class.focussitecalllite-admin-post-controller.php' );

require_once( 'class.focussitecalllite-notices.php' );

require_once( 'class.focussitecalllite-sitecall.php' );


class FocusSitecallLite_Admin_Settings_Page {
	private $credentials;

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'page_init' ) );

		( new FocusSitecallLite_Admin_Post_Controller() )->register_actions();

		$this->credentials = new FocusSitecallLite_Credentials();
	}

	public function add_plugin_page() {
		add_menu_page(
			'Focus Sitecall Lite',
			'Focus Sitecall Lite',
			'manage_options',
			FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME,
			array( $this, 'create_admin_page' ),
            plugins_url() . '/' . dirname( plugin_basename( __FILE__ ) ) . '/images/sitecalllogolite.svg'
        );
	}

	public function create_admin_page() {

	    if (isset($_GET['sitecall_id'])):

            ( new FocusSiteCallLite_Sitecall() )->display();

        else:

            settings_errors();

            echo FocusSitecallLite_Notices::displayNotices( FocusSitecallLite_Notices::NOTICE_SUCCESS );
            echo FocusSitecallLite_Notices::displayNotices( FocusSitecallLite_Notices::NOTICE_ERROR );

            $this->credentials->create_admin_page();


            $sitercalls_list_table = new FocusSitecallLite_Sitecalls_List_Table();
            $sitercalls_list_table->prepare_items();

            $templates_sitercalls_list_table = new FocusSitecallLite_Templates_Sitecalls_List_Table();
            $templates_sitercalls_list_table->prepare_items();

            ?>


            <div class="wrap">
                <h2><?php _e('List of SiteCall widgets', 'focus-sitecall-lite'); ?></h2>

                <form action="admin-post.php" method="POST">
                    <?php $sitercalls_list_table->display(); ?>

                    <input type="hidden" name="action" value="focussitecalllite_actions_on_sitecalls">
                </form>
            </div>


            <div class="wrap">
                <h2><?php _e('List of themes assigned to SiteCall widgets', 'focus-sitecall-lite'); ?></h2>

                <form action="admin-post.php" method="POST">
                    <?php $templates_sitercalls_list_table->display(); ?>

                    <input type="hidden" name="action" value="focussitecalllite_assign_sitecalls">
                </form>
            </div>

		<?php

        endif;
	}

	public function page_init() {
		$this->credentials->page_init();
	}
}