<?php

class FocusSitecallLite_Credentials {
	private $options;

	public function __construct()
    {
        $this->options = get_option( 'FocusSitecallLite_credentials_option' );
    }

    public function create_admin_page() {
		?>

        <div class="wrap">
            <h1><?php _e('Focus SiteCall Lite settings', 'focus-sitecall-lite'); ?></h1>

            <p style="font-size:16px;"><?php printf(
                    __('Generate extra leads for 7 days free of charge. Visit %s and create an account today!', 'focus-sitecall-lite'),
                    '<a href="https://focustelecom.pl/sitecall/" target="_blank">https://focustelecom.pl/sitecall/</a>'); ?></p>

            <form method="post" action="admin-post.php">
                <?php
                    settings_fields( 'FocusSitecallLite_credentials_option_group' );
                    echo '<table class="form-table">';
                        do_settings_fields( FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'FocusSitecallLite_credentials_section' );
                    echo '</table>';
                ?>
                <input type="hidden" name="action" value="focussitecalllite_update_credentials"/>

                <?php submit_button( __('Save changes', 'focus-sitecall-lite') ); ?>
            </form>

		<?php
	}

	public function page_init() {
		register_setting(
			'FocusSitecallLite_credentials_option_group', // Option group
			'FocusSitecallLite_credentials_option', // Option name
			array( $this, 'sanitize' ) // Sanitize
		);

		add_settings_section(
			'FocusSitecallLite_credentials_section', // ID
			__('General settings', 'focus-sitecall-lite'), // Title
			array( $this, 'print_section_info' ), // Callback
			FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME// Page
		);

		add_settings_field(
			'emailAddressNotification', // ID
			__('Email addresses to send mail notifications', 'focus-sitecall-lite'), // Title
			array( $this, 'email_address_notification_callback' ), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
			'FocusSitecallLite_credentials_section' // Section
		);
	}


	public function sanitize( $input ) {
		$new_input = array();
		if ( isset( $input['emailAddressNotification'] ) ) {
			$new_input['emailAddressNotification'] = sanitize_text_field( $input['emailAddressNotification'] );
		}
		return $new_input;
	}


	public function print_section_info() {
	}

	public function email_address_notification_callback() {
		printf(
			'<textarea style="height:5em; width:50em;" id="emailAddressNotification" name="FocusSitecallLite_credentials_option[emailAddressNotification]">%s</textarea>',
			isset( $this->options['emailAddressNotification'] ) ? esc_attr( $this->options['emailAddressNotification'] ) : ''
		);
	}
}