<?php

require_once( 'class.focussitecalllite-model.php' );

class FocusSitecallLite_Notices extends FocusSitecallLite_Model {
	const NOTICE_ERROR = 'notice-error';
	const NOTICE_WARNING = 'notice-warning';
	const NOTICE_SUCCESS = 'notice-success';
	const NOTICE_INFO = 'notice-info';

	const NOTICES_OPTION_KEY = 'FocusSitecallLite_notices';

	public static function getNotices( $type ) {
		$notices = self::getAllByKey( self::NOTICES_OPTION_KEY );

		$noticesToReturn = isset( $notices[ $type ] ) ? $notices[ $type ] : [];

		unset( $notices[ $type ] );

		self::setAllByKey( $notices, self::NOTICES_OPTION_KEY );

		return $noticesToReturn;
	}

	public static function setNotice( $type, $notice ) {
		$notices = self::getAllByKey( self::NOTICES_OPTION_KEY );

		$notices[ $type ][] = $notice;

		self::setAllByKey( $notices, self::NOTICES_OPTION_KEY );
	}

	public static function displayNotices( $type ) {
		$notices = self::getNotices( $type );

		$displayableNotice = '';

		foreach ( $notices as $notice ) {
			$displayableNotice .= '<div class="notice ' . $type . ' is-dismissible">
                <p>' . $notice . '</p>
            </div>';
		}

		return $displayableNotice;
	}
}