<?php

require_once('class.focussitecallltie-template.php');
if ( ! class_exists( 'wp_mail' ) ) {
    require_once( ABSPATH . 'wp-load.php' );
}

class FocusSitecallLite_Provider extends FocusSitecallLite_Model
{
    public function __construct()
    {
        $this->init();
    }

    private function init()
    {
        add_action( 'wp_ajax_nopriv_focussitecalllite-callback', [$this, 'callback'] );
        add_action( 'wp_ajax_focussitecalllite-callback', [$this, 'callback'] );
    }

    public function callback()
    {
        $mailAddresses = get_option( 'FocusSitecallLite_credentials_option' )['emailAddressNotification'];
        $mailAddresses = explode(',', $mailAddresses);
        $mailAddresses = array_map('trim', $mailAddresses);

        add_filter( 'wp_mail_from', function() use ($mailAddresses) {
            return $mailAddresses[0];
        } );

        $dataReceived = json_decode(file_get_contents('php://input'), true);

        FocusSitecallLite_Sitecalls_Model::setCounter($dataReceived['id']);
        FocusSitecallLite_Sitecalls_Model::setConnections($dataReceived['id']);

        $subject = sprintf(__('SiteCall Lite (%s)', 'focus-sitecall-lite'), $dataReceived['name']);

        $template = new FocusSiteCallLite_Template($dataReceived['id']);
        $message = $template->getPreparedTemplate($dataReceived);

        wp_mail($mailAddresses, $subject, $message, ['Content-Type: text/html; charset=UTF-8']);

        die;
    }
}