<?php


class FocusSiteCallLite_Sitecall_Agreements_Model extends FocusSitecallLite_Sitecalls_Model
{
    public static function getAgreementsByWidgetId($sitecallId)
    {
        $allSitecalls = self::getAll();
        $sitecallKey = array_search($sitecallId, array_column($allSitecalls, 'id'));

        if ($sitecallKey === false) {
            return [];
        }

        return $allSitecalls[$sitecallKey]['data']['agreements'];
    }

    public static function addNewAgreement($sitecallId)
    {
        $allSitecalls = self::getAll();
        $sitecallKey = array_search($sitecallId, array_column($allSitecalls, 'id'));

        if ($sitecallKey === false) {
            return false;
        }

        $allSitecalls[$sitecallKey]['data']['agreements'][] = [
            'id' => FocusSiteCallLite_Tools::gen_uuid(),
            'description' => '',
            'required' => false
        ];

        self::setAll($allSitecalls);

        return true;
    }

    public static function deleteAgreements($sitecallId, array $agreementsIdsToDelete)
    {
        $allSitecalls = self::getAll();
        $sitecallKey = array_search($sitecallId, array_column($allSitecalls, 'id'));

        if ($sitecallKey === false) {
            return false;
        }


        $deleted = 0;

        $allSitecallAgreements = &$allSitecalls[$sitecallKey]['data']['agreements'];

        foreach ($agreementsIdsToDelete as $agreementIdToDelete) {
            $agreementKey = array_search($agreementIdToDelete, array_column($allSitecallAgreements, 'id'));

            if ($agreementKey !== false) {
                unset($allSitecallAgreements[$agreementKey]);

                $allSitecallAgreements = array_values($allSitecallAgreements);

                $deleted++;
            }
        }

        FocusSitecallLite_Sitecalls_Model::setAll($allSitecalls);

        return (bool)$deleted;
    }


}