<?php

require_once( 'class.focussitecalllite-tools.php' );
require_once( 'class.focussitecalllite-sitecall-agreements-list-table.php');


class FocusSiteCallLite_Sitecall
{
    private $widgetData;
    private $widgetId;

    private $default_css;

    public function __construct()
    {
        $this->default_css = '/*' . __('Launcher', 'focus-sitecall-lite') . '*/
.public-btn-launcher {
}

/*' . __('Main window of SiteCall widget', 'focus-sitecall-lite') . '*/
.public-window {
}

/*' . __('The header of the SiteCall window, visible at each stage. It contains a `closing` button - .public-btn-window-close', 'focus-sitecall-lite') .'*/
.public-header {
}

/*' . __('The main part of the SiteCall window, in which there are individual stages', 'focus-sitecall-lite') . '*/
.public-body {
}

/*' . __('The `closing` button, in the thanks stage', 'focus-sitecall-lite') . '*/
.public-btn-close {
}

/*' . __('The `main` button closing the SiteCall window, located in the `public-header`', 'focus-sitecall-lite') . '*/
.public-btn-window-close {
}

/*' . __('`Confirmation` key, when setting the date of callback', 'focus-sitecall-lite') . '*/
.public-btn-confirm {
}

/*' . __('Button for entering the number', 'focus-sitecall-lite') . '*/
.public-btn-call {
}

/*' . __('Counter at the handset', 'focus-sitecall-lite') . '*/
.public-btn-launcher-counter {
}

/*' . __('Text at the stage of acceptance of agreements', 'focus-sitecall-lite') . '*/
.public-agreements-header {
}

/*' . __('Stage for entering the number', 'focus-sitecall-lite') . '*/
.public-step-call {
}

/*' . __('Stage of date selection', 'focus-sitecall-lite') . '*/
.public-step-pick-date {
}

/*' . __('Stage of thanks', 'focus-sitecall-lite') . '*/
.public-step-after-success {
}

/*' . __('Stage of GDPR agreements', 'focus-sitecall-lite') . '*/
.public-step-agreements {
}';

        $this->pageInit();
    }

    public function display() {
        $id = $this->widgetId;

        $sitecalls_agreements_list_table = new FocusSiteCallLite_Sitecall_Agreements_List_Table($this->widgetId);
        $sitecalls_agreements_list_table->prepare_items();

        ?>

        <div class="wrap">

            <div id="icon-themes" class="icon32"></div>
            <h2><?= sprintf(__('Sitecall settings (%s)', 'focus-sitecall-lite'), empty($this->widgetData) ? __('Sitecall Name #', 'focus-sitecall-lite') . explode('-', $this->widgetId)[0] : $this->widgetData['name']); ?></h2>
            <img src="<?= plugins_url() . '/' . dirname( plugin_basename( __FILE__ ) ) . '/images/LogoSiteCallLiteFullLogo.png' ?>" style="width:300px;margin-top:20px;" />
            <?php
                settings_errors();

                echo FocusSitecallLite_Notices::displayNotices( FocusSitecallLite_Notices::NOTICE_SUCCESS );
                echo FocusSitecallLite_Notices::displayNotices( FocusSitecallLite_Notices::NOTICE_ERROR );
            ?>

            <form action="admin-post.php" method="POST">

                <?php
                    echo '<table class="form-table sitecall-general-settings" style="margin-bottom:40px;">';
                        do_settings_fields( FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'FocusSitecallLite_sitecallSettings_section_general' );
                    echo '</table>';
                ?>

                    <?php $tab = isset($_GET['tab']) ? $_GET['tab'] : ''; ?>

                    <!-- Start tabs -->
                    <ul class="wp-tab-bar">
                        <li <?= $tab !== 'agreements' ? 'class="wp-tab-active"' : ''; ?>><a href="#tabs-1">
                                <?php _e('Entering the phone number', 'focus-sitecall-lite'); ?></a></li>
                        <li ><a href="#tabs-2">
                                <?php _e('Entering the date', 'focus-sitecall-lite'); ?></a></li>
                        <li ><a href="#tabs-3">
                                <?php _e('Thanks for contact', 'focus-sitecall-lite'); ?></a></li>
                        <li <?= $tab === 'agreements' ? 'class="wp-tab-active"' : ''; ?>><a href="#tabs-4">
                                <?php _e('Agreements', 'focus-sitecall-lite'); ?></a></li>
                    </ul>
                    <div class="wp-tab-panel" id="tabs-1" <?= $tab === 'agreements' ? 'style="display: none;"' : ''; ?>>
                        <?php
                            echo '<table class="form-table">';
                                do_settings_fields( FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'FocusSitecallLite_sitecallSettings_section_call' );
                            echo '</table>';
                        ?>
                    </div>
                    <div class="wp-tab-panel" id="tabs-2" <?= 'style="display: none;"'; ?>>
                        <?php
                        echo '<table class="form-table">';
                            do_settings_fields( FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'FocusSitecallLite_sitecallSettings_section_recall' );
                        echo '</table>';
                        ?>
                    </div>
                    <div class="wp-tab-panel" id="tabs-3" <?= 'style="display: none;"'; ?>>
                        <?php
                        echo '<table class="form-table">';
                           do_settings_fields( FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'FocusSitecallLite_sitecallSettings_section_after_call' );
                        echo '</table>';
                        ?>
                    </div>
                <div class="wp-tab-panel" id="tabs-4" <?= $tab !== 'agreements' ? 'style="display: none;"' : ''; ?>>
                    <div class="wrap">
                        <h2><?php _e('List of agreements', 'focus-sitecall-lite'); ?></h2>

                        <?php

                        echo '<table class="form-table">';
                            do_settings_fields(FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'FocusSitecallLite_sitecallSettings_section_agreements');
                        echo '<table class="form-table">';

                        ?>

                        <?php $sitecalls_agreements_list_table->display(); ?>
                    </div>
                </div>

                <input type="hidden" name="action" id="action" value="focussitecalllite_save_sitecall" />
                <input type="hidden" name="id" id="id" value="<?= $id ?>" />
                <?= '<input type="hidden" name="_wp_http_referer" value="'.
                    str_replace('sitecall_id=new', 'sitecall_id=' . $id, esc_attr( wp_unslash( $_SERVER['REQUEST_URI'] ) ) . '" />');
                ?>

                <?php submit_button( __('Save changes', 'focus-sitecall-lite') ); ?>
            </form>

        </div>
<?php
    }

    public function pageInit()
    {
        $this->widgetId = isset($_GET['sitecall_id']) && $_GET['sitecall_id'] !== 'new' ? $_GET['sitecall_id'] : FocusSiteCallLite_Tools::gen_uuid();

        $this->widgetData = FocusSitecallLite_Sitecalls_Model::getWidgetById($this->widgetId);

        register_setting(
            'FocusSitecallLite_sitecallSettings_option_group', // Option group
            'FocusSitecallLite_sitecallSettings_option', // Option name
            array( $this, 'sanitize' ) // Sanitize
        );


        /*
         * General section
         * */


        add_settings_section(
            'FocusSitecallLite_sitecallSettings_section_general', // ID
            __('General SiteCall settings', 'focus-sitecall-lite'), // Title
            array( $this, 'print_section_info' ), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME // Page
        );

        add_settings_field(
            'sitecallName', // ID
            __('Name', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_general',
            array(
                'type' => 'text',
                'id' => 'sitecallName',
                'value' => empty($this->widgetData) ? __('Sitecall Name #', 'focus-sitecall-lite') . explode('-', $this->widgetId)[0] : $this->widgetData['name'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionGeneral',
                'style' => 'width: 300px',
                'echo' => true)
        );

        add_settings_field(
            'sitecallPosition', // ID
            __('Widget position', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_general',
            array(
                'type' => 'select',
                'id' => 'sitecallPosition',
                'options' => [
                    [
                        'value' => '1',
                        'name' => __('Top left corner', 'focus-sitecall-lite')
                    ],
                    [
                        'value' => '2',
                        'name' => __('Top', 'focus-sitecall-lite')
                    ],
                    [
                        'value' => '3',
                        'name' => __('Top right corner', 'focus-sitecall-lite')
                    ],
                    [
                        'value' => '4',
                        'name' => __('Left side', 'focus-sitecall-lite')
                    ],
                    [
                        'value' => '5',
                        'name' => __('Right side', 'focus-sitecall-lite')
                    ],
                    [
                        'value' => '6',
                        'name' => __('Bottom left corner', 'focus-sitecall-lite')
                    ],
                    [
                        'value' => '7',
                        'name' => __('Bottom', 'focus-sitecall-lite')
                    ],
                    [
                        'value' => '8',
                        'name' => __('Bottom right corner', 'focus-sitecall-lite')
                    ],
                ],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionGeneral',
                'value' => empty($this->widgetData) ? '8' : $this->widgetData['data']['general']['launcherPosition'],
                'style' => '',
                'echo' => true)
        );

        add_settings_field(
            'sitecallWindowBackgroundColor', // ID
            FocusSiteCallLite_Tools::changeSpaceToNbsp(__('Window background color', 'focus-sitecall-lite')), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_general',
            array(
                'type' => 'color',
                'id' => 'sitecallWindowBackgroundColor',
                'value' => empty($this->widgetData) ? '#ffffff' : $this->widgetData['data']['general']['windowBackgroundColor'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionGeneral',
                'style' => 'width: 50px',
                'echo' => true)
        );


        add_settings_field(
            'sitecallLauncherBackgroundColor', // ID
            FocusSiteCallLite_Tools::changeSpaceToNbsp(__('Widgets\' launcher background color', 'focus-sitecall-lite')), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_general',
            array(
                'type' => 'color',
                'id' => 'sitecallLauncherBackgroundColor',
                'value' => empty($this->widgetData) ? '#1488AB' : $this->widgetData['data']['general']['launcherBackgroundColor'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionGeneral',
                'style' => 'width: 50px',
                'echo' => true)
        );

        add_settings_field(
            'sitecallButtonColor', // ID
            __('Button color', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_general',
            array(
                'type' => 'color',
                'id' => 'sitecallButtonColor',
                'value' => empty($this->widgetData) ? '#ff0002' : $this->widgetData['data']['general']['buttonColor'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionGeneral',
                'style' => 'width: 50px',
                'echo' => true)
        );

        add_settings_field(
            'sitecallCss', // ID
            __('CSS', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_general',
            array(
                'type' => 'textarea',
                'id' => 'sitecallCss',
                'value' => empty($this->widgetData) ?  $this->default_css : $this->widgetData['data']['general']['css'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionGeneral',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );


        /*
         * Call section
         * */

        add_settings_section(
            'FocusSitecallLite_sitecallSettings_section_call', // ID
            __('Call SiteCall settings', 'focus-sitecall-lite'), // Title
            array($this, 'print_section_info'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME // Page
        );

        add_settings_field(
            'sitecallCallText1', // ID
            __('Text when entering the phone number', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_call',
            array(
                'type' => 'textarea',
                'id' => 'sitecallCallText1',
                'value' => empty($this->widgetData) ? __('Enter the phone number', 'focus-sitecall-lite') : $this->widgetData['data']['call']['headerText'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionCall',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        add_settings_field(
            'sitecallCallText2', // ID
            __('Text of the privacy of personal data when entering a phone number', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_call',
            array(
                'type' => 'textarea',
                'id' => 'sitecallCallText2',
                'value' => empty($this->widgetData) ? __('Your phone number will not be used for marketing purposes or passed on. We will only call you back.', 'focus-sitecall-lite')
                    : $this->widgetData['data']['call']['footerText'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionCall',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        add_settings_field(
            'sitecallCallGoNextButton', // ID
            __('Text of the button when entering the phone number', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_call',
            array(
                'type' => 'textarea',
                'id' => 'sitecallCallGoNextButton',
                'value' => empty($this->widgetData) ? __('Leave a phone number', 'focus-sitecall-lite')
                    : $this->widgetData['data']['call']['goNextButton'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionCall',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        /*
         * Selecting Recall section
         * */

        add_settings_section(
            'FocusSitecallLite_sitecallSettings_section_recall', // ID
            __('Call SiteCall settings', 'focus-sitecall-lite'), // Title
            array($this, 'print_section_info'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME // Page
        );

        add_settings_field(
            'sitecallRecallText1', // ID
            __('Text when setting the date of the callback', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_recall', //Section
            array(
                'type' => 'textarea',
                'id' => 'sitecallRecallText1',
                'value' => empty($this->widgetData) ? __('Select a date and time to callback', 'focus-sitecall-lite') : $this->widgetData['data']['recall']['headerText'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionRecall',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        add_settings_field(
            'sitecallRecallGoNextButton', // ID
            __('Text of the button after ordering the call', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_recall',
            array(
                'type' => 'textarea',
                'id' => 'sitecallRecallGoNextButton',
                'value' => empty($this->widgetData) ? __('Choose date', 'focus-sitecall-lite')
                    : $this->widgetData['data']['recall']['goNextButton'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionRecall',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );


        /*
         * After Call section
         * */

        add_settings_section(
            'FocusSitecallLite_sitecallSettings_section_after_call', // ID
            __('After call SiteCall settings', 'focus-sitecall-lite'), // Title
            array( $this, 'print_section_info' ), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME // Page
        );


        add_settings_field(
            'sitecallAfterCallText1', // ID
            __('Text after ordering the call', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_after_call', //Section
            array(
                'type' => 'textarea',
                'id' => 'sitecallAfterCallText1',
                'value' => empty($this->widgetData) ? __('Thank you for order the call.', 'focus-sitecall-lite') : $this->widgetData['data']['afterCall']['headerText'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionAfterCall',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        add_settings_field(
            'sitecallRecallGoNextButton', // ID
            __('Text of the closing button after ordering the call', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_after_call',
            array(
                'type' => 'textarea',
                'id' => 'sitecallAfterCallGoNextButton',
                'value' => empty($this->widgetData) ? __('Close', 'focus-sitecall-lite')
                    : $this->widgetData['data']['afterCall']['goNextButton'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_optionAfterCall',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        /*agreements section*/

        add_settings_section(
            'FocusSitecallLite_sitecallSettings_section_agreements', // ID
            __('Call SiteCall settings', 'focus-sitecall-lite'), // Title
            array($this, 'print_section_info'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME // Page
        );

        add_settings_field(
            'sitecallAgreementsHeaderText', // ID
            __('Text before accepting the agreements', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_agreements',
            array(
                'type' => 'textarea',
                'id' => 'sitecallAgreementsHeaderText',
                'value' => empty($this->widgetData) ? __('Before the call, please accept the agreements', 'focus-sitecall-lite') : $this->widgetData['data']['agreementsStep']['headerText'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_section_agreements',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        add_settings_field(
            'sitecallAgreementsButtonText', // ID
            __('Text of the button when accepting the agreements', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_agreements',
            array(
                'type' => 'textarea',
                'id' => 'sitecallAgreementsButtonText',
                'value' => empty($this->widgetData) ? __('Next', 'focus-sitecall-lite') : $this->widgetData['data']['agreementsStep']['goNextButton'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_section_agreements',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );

        add_settings_field(
            'sitecallAgreementsRequirmentFieldLabel', // ID
            __('Text `required fields`', 'focus-sitecall-lite'), // Title
            array('FocusSiteCallLite_Tools', 'createField'), // Callback
            FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, // Page
            'FocusSitecallLite_sitecallSettings_section_agreements',
            array(
                'type' => 'textarea',
                'id' => 'sitecallAgreementsRequirmentFieldLabel',
                'value' => empty($this->widgetData) ? __('Required field', 'focus-sitecall-lite') : $this->widgetData['data']['agreementsStep']['requiredFieldLabel'],
                'optionGroupName' => 'FocusSitecallLite_sitecallSettings_section_agreements',
                'style' => 'height:10em; width:90%;',
                'echo' => true)
        );
    }


    public function sanitize( $input ) {
        $new_input = array_map('sanitize_text_field', $input);

        return $new_input;
    }


    public function print_section_info() {
    }
}
