<?php
require_once( 'class.focussitecalllite-sitecalls-model.php' );
require_once( 'class.focussitecalllite-templates-sitecalls-model.php' );


if ( ! class_exists( 'WP_List_Table' ) ) {
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}

class FocusSitecallLite_Sitecalls_List_Table extends WP_List_Table {

	public function __construct( $args = array() ) {
		parent::__construct( $args );
	}

	public function prepare_items() {
		$columns  = $this->get_columns();
		$hidden   = $this->get_hidden_columns();
		$sortable = $this->get_sortable_columns();
		$data     = $this->table_data();

		usort( $data, array( &$this, 'sort_data' ) );

		$perPage = 10;

		$currentPage = $this->get_pagenum();
		$totalItems  = count( $data );
		$this->set_pagination_args( array(
			'total_items' => $totalItems,
			'per_page'    => $perPage
		) );
		$data                  = array_slice( $data, ( ( $currentPage - 1 ) * $perPage ), $perPage );
		$this->_column_headers = array( $columns, $hidden, $sortable );
		$this->items           = $data;
	}

	public function get_columns() {
		$columns = array(
		    'cb'     => '<input type="checkbox" />',
			'idDisplayableLink'     => __('Name', 'focus-sitecall-lite'),
            'connections' => __('Ordered calls', 'focus-sitecall-lite'),
		);

		return $columns;
	}

	public function get_hidden_columns() {
		return array();
	}

	public function get_sortable_columns() {
		return array();
	}

	private function table_data() {

        $allSitecalls = FocusSitecallLite_Sitecalls_Model::getAll();

        $allSitecalls = array_map(function ($item) {
            $item['idDisplayableLink'] = sprintf(
                '<a href="' . '?' . http_build_query(['page' => FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'sitecall_id' => $item['id']]) . '">%s</a>',
                $item['name']);
            return $item;
        }, $allSitecalls);

	    return $allSitecalls;
	}

	public function column_default( $item, $column_name ) {
		switch ( $column_name ) {
			case 'id':
            case 'idDisplayableLink':
				return $item[ $column_name ];
				break;
            case 'connections':
                return isset($item['data']['general']['connections']) ? $item['data']['general']['connections'] : 0;
			default:
				return '';
		}
	}

    public function column_cb( $item ) {
        return sprintf(
            '<input type="checkbox" name="bulk-delete[]" value="%s" />', $item['id']
        );
    }

    public function get_bulk_actions() {
        return [];
    }

	public function extra_tablenav( $which ) {
	    if ($which == 'top') {
            echo '<a href="?' . http_build_query(['page' => FocusSitecallLite::ADMIN_SETTINGS_PAGE_NAME, 'sitecall_id' => 'new']) . '">
                    <input style="margin-right: 10px" type="button" value="' . __('Add', 'focus-sitecall-lite') . '" class="button"></a>';

            echo '<input type="submit" name="delete_sitecalls_button" value="' . __('Delete', 'focus-sitecall-lite') . '" class="button" />';
	    }
	}
}