<?php

class FocusSiteCallLite_Tools
{
    const DEFAULT_MAXLENGTH = 200;

    public static function generateUrl($data)
    {


    }

    public static function gen_uuid() {
        return sprintf( '%04x%04x-%04x-%04x-%04x-%04x%04x%04x',
            // 32 bits for "time_low"
            mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ),

            // 16 bits for "time_mid"
            mt_rand( 0, 0xffff ),

            // 16 bits for "time_hi_and_version",
            // four most significant bits holds version number 4
            mt_rand( 0, 0x0fff ) | 0x4000,

            // 16 bits, 8 bits for "clk_seq_hi_res",
            // 8 bits for "clk_seq_low",
            // two most significant bits holds zero and one for variant DCE1.1
            mt_rand( 0, 0x3fff ) | 0x8000,

            // 48 bits for "node"
            mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff ), mt_rand( 0, 0xffff )
        );
    }

    public static function createField(array $args)
    {
        $field = '';
        $args['optionGroupName'] = $args['optionGroupName'] . '[' . $args['id'] .  ']';

        switch($args['type']) {
            case 'textarea':
                $field = sprintf('<textarea id="%s" name="%s" style="%s" %s>%s</textarea>',
                    $args['id'],
                    $args['optionGroupName'],
                    $args['style'],
                    isset($args['maxlength']) ? 'maxlength=' . $args['maxlength'] : 'maxlength="' . self::DEFAULT_MAXLENGTH . '"',
                    $args['value']);
            break;

            case 'text':
                $field = sprintf('<input type="text" id="%s" name="%s" value="%s" style="%s" %s/>',
                    $args['id'],
                    $args['optionGroupName'],
                    $args['value'],
                    $args['style'],
                    isset($args['maxlength']) ? 'maxlength="' . $args['maxlength'] . '"' : 'maxlength="' . self::DEFAULT_MAXLENGTH . '"');
            break;

            case 'color':
                $field = sprintf('<input type="color" id="%s" name="%s" value="%s" style="%s"/>',
                    $args['id'], $args['optionGroupName'], $args['value'], $args['style']);
            break;

            case 'select':
                $field = sprintf('<select id="%s" name="%s" style="%s">', $args['id'], $args['optionGroupName'], $args['style']);

                foreach($args['options'] as $option) {
                    $field .= sprintf('<option value="%s" %s>%s</option>',
                        $option['value'],
                        ($args['value'] == $option['value'] ? 'selected' : ''),
                        $option['name']);
                }

                $field .= '</select>';
            break;
        }

        if ($args['echo']) {
            echo $field;
        } else {
            return $field;
        }
    }

    public static function changeSpaceToNbsp($text)
    {
        return str_replace(' ', '&nbsp;', $text);
    }
}
