<?php

class FocusSiteCallLite_Template
{
    private $widgetId;

    const BODY_MARK = '__BODY_DATA__';
    const YEAR_MARK = '__YEAR__';

    public function __construct($widgetId)
    {
        $this->widgetId = $widgetId;
    }

    private function getTemplate()
    {
        $footerText = __('Thank you for using the Focus Telecom Poland business tools', 'focus-sitecall-lite');
        $template = <<<EOD
<html>
<head>
    <title></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>
<!-- Facebook sharing information tags -->
<body>
<center>
    <table id="backgroundTable" style="margin: 0; padding: 0; background-color: #fafafa; height: 100%; width: 100%;" border="0" width="100%" cellspacing="0" cellpadding="0">
        <tbody>
        <tr>
            <td style="border-collapse: collapse;" align="center" valign="top"><!-- // Begin Template Preheader \ -->
                <!-- // End Template Preheader \ -->
                <table id="templateContainer" style="border: 1px solid #DDDDDD; background-color: #ffffff;" border="0" width="600" cellspacing="0" cellpadding="0">
                    <tbody>
                    <tr>
                        <td style="border-collapse: collapse;" align="center" valign="top"><!-- // Begin Template Header \ -->
                            <table id="templateHeader" style="background-color: #ffffff; border-bottom: 0;" border="0" width="600" cellspacing="0" cellpadding="0">
                                <tbody>
                                <tr>
                                    <td class="headerContent" style="border-collapse: collapse; color: #202020; font-family: Arial; font-size: 34px; font-weight: bold; line-height: 34px; padding: 0; text-align: center; vertical-align: middle;"><!-- // End Module: Standard Header Image \ --></td>
                                </tr>
                                </tbody>
                            </table>
                            <!-- // End Template Header \ --></td>
                    </tr>
                    <tr>
                        <td style="border-collapse: collapse;" align="center" valign="top"><!-- // Begin Template Body \ -->
                            <table id="templateBody" border="0" width="600" cellspacing="0" cellpadding="0">
                                <tbody>
                                <tr>
                                    <td class="bodyContent" style="border-collapse: collapse; background-color: #ffffff;" valign="top"><!-- // Begin Module: Standard Content \ -->
                                        <table border="0" width="100%" cellspacing="0" cellpadding="20">
                                            <tbody>
                                            <tr>
                                                <td style="border-collapse: collapse;" valign="top">
                                                    <div class="" style="color: #505050; font-family: Arial; font-size: 14px; line-height: 21px; text-align: left; background: #ffffff;">
                                                        <h1 class="h1" style="color: #202020; display: block; font-family: Arial; font-size: 34px; font-weight: bold; line-height: 34px; margin: 0px 0px 10px; text-align: center;"><br /> <img style="width: 200px; height: 47px; border-width: 0px; border-style: solid;" src="http://go.pardot.com/l/172012/2016-05-25/7nq3/172012/2232/logoftp.gif" alt="" width="200" height="47" border="0" /></h1>

                                                        <div style="text-align: center;"><br /> <br /> &nbsp;</div>

                                                        __BODY_DATA__

                                                        <h2 style="text-align: center;"><img style="width: 0px; float: left;" src="http://go.pardot.com/images/addthis/16x16/blank-block.png" alt="blank" /></h2>
                                                        &nbsp;
                                                        <div><img style="width: 0px; float: left;" src="http://go.pardot.com/images/addthis/16x16/blank-block.png" alt="blank" /></div>
                                                        <div style="color: #222222; font-family: arial, sans-serif; font-size: 12.8px;">&nbsp;</div>
                                                        <p style="text-align: center;">{$footerText}<br /> &nbsp;</p>
                                                        <div style="text-align: center;">
                                                            <div><img style="border-width: 0px; border-style: solid; height: 47px; width: 200px;" src="http://go.pardot.com/l/172012/2016-05-30/bnxw/172012/2802/logoftp.gif" alt="" width="200" height="47" border="0" /></div>
                                                            <div style="text-align: left;"><br /> &nbsp;</div>
                                                        </div>
                                                    </div>
                                                </td>
                                            </tr>
                                            </tbody>
                                        </table>
                                        <!-- // End Module: Standard Content \ --></td>
                                </tr>
                                </tbody>
                            </table>
                            <!-- // End Template Body \ --></td>
                    </tr>
                    <tr>
                        <td style="border-collapse: collapse;" align="center" valign="top"><!-- // Begin Template Footer \ -->
                            <table id="templateFooter" style="background-color: #ffffff; border-top: 0;" border="0" width="600" cellspacing="0" cellpadding="10">
                                <tbody>
                                <tr>
                                    <td class="footerContent" style="border-collapse: collapse;" valign="top"><!-- // Begin Module: Standard Footer \ -->
                                        <table border="0" width="100%" cellspacing="0" cellpadding="10">
                                            <tbody>
                                            <tr>
                                                <td style="border-collapse: collapse;" valign="top" width="350">
                                                    <div style="color: #707070; font-family: Arial; font-size: 12px; line-height: 15px; text-align: left;"><em>Focus Telecom Polska Sp. z o. o. __YEAR__ , All rights reserved.</em></div>
                                                </td>
                                                <td style="border-collapse: collapse;" valign="top" width="190">
                                                    <div style="color: #707070; font-family: Arial; font-size: 12px; line-height: 15px; text-align: left;">&nbsp;</div>
                                                </td>
                                            </tr>
                                            </tbody>
                                        </table>
                                        <!-- // End Module: Standard Footer \ --></td>
                                </tr>
                                </tbody>
                            </table>
                            <!-- // End Template Footer \ --></td>
                    </tr>
                    </tbody>
                </table>
            </td>
        </tr>
        </tbody>
    </table>
</center>
</body>
</html>
EOD;

        return $template;
    }

    private function prepareBody(array $data)
    {
        $html = __('Date', 'focus-sitecall-lite') .': ' . '%s<br>'
            . __('Time', 'focus-sitecall-lite') .': ' . '%s<br>'
            . __('Widget name', 'focus-sitecall-lite') .': ' . '%s<br>'
            . __('Phone number', 'focus-sitecall-lite') .': ' . '%s<br>'
            . __('Date of callback', 'focus-sitecall-lite') .': ' . '%s<br>'
            . __('Website address', 'focus-sitecall-lite') .': ' . '%s';

        $html = sprintf($html,
            current_time('d-m-Y'),
            current_time('H:i'),
            $data['name'], $data['phoneNumber'],
            $data['callDate'],
            site_url());

        if (!empty($data['agreements'])) {
            $html .= '<table style="border: 0; border-collapse: collapse;margin-top:30px;">';

            foreach($data['agreements'] as $agreement) {

                $agreementAccepted = $agreement['value'] ? __('Agreement accepted', 'focus-sitecall-lite') : __('Agreement not accepted', 'focus-sitecall-lite');

                $html .= '<tr>';
                $html .= '<td style="padding:5px;text-align:left;color:#505050; font-family:Arial; font-size:14px; line-height:21px; vertical-align:center;border:0;">' . $agreement['description'] . '</td>';
                $html .= '<td style="padding:5px;text-align:left;color:#505050; font-family:Arial; font-size:14px; line-height:21px; vertical-align:center;border:0;">' . $agreementAccepted . '</td>';
                $html .= '</tr>';

            }

            $html .= '</table>';
        }

        return $html;
    }

    public function getPreparedTemplate(array $data)
    {
        $str = str_replace(self::BODY_MARK, $this->prepareBody($data), $this->getTemplate());
        $str = str_replace(self::YEAR_MARK, current_time('Y'), $str);

        return $str;
    }
}
