<?php
require_once( 'class.focussitecalllite-admin-settings-page.php' );
require_once( 'class.focussitecalllite-add-widget.php' );
require_once( 'class.focussitecalllite-provider.php' );

/*
	Plugin Name: Focus SiteCall Lite
	Author: Focus Telecom Polska Sp. z o.o.
	Author URI: https://focustelecom.pl/
	Description: Plugin allows to add Focus SiteCall Lite widget to page.
	Version: 1.0.1
    Text Domain: focus-sitecall-lite
    Domain Path: /languages
 */

class FocusSitecallLite {
	const TEXT_DOMAIN = 'focus-sitecall-lite';

	const ADMIN_SETTINGS_PAGE_NAME = 'focussitecalllite-settings-admin';

    private $admin_settings_page;

	public function __construct() {
        add_action('init', [$this, 'FocusSitecallLite_init']);

	    ( new FocusSitecallLite_Add_Widget() )->register_actions();
		$this->admin_settings_page = new FocusSitecallLite_Admin_Settings_Page();
    }

    public function FocusSitecallLite_init() {
        load_plugin_textdomain( 'focus-sitecall-lite', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );

        wp_register_script( 'FocusSiteCallLite-admin-tabs', plugins_url( '/js/admin-tabs.js', __FILE__ ) );
        wp_enqueue_script( 'FocusSiteCallLite-admin-tabs' );

        wp_register_style( 'FocusSiteCallLite-admin-tabs', plugins_url( '/css/admin-tabs.css', __FILE__ ) );
        wp_enqueue_style( 'FocusSiteCallLite-admin-tabs' );

        wp_register_style( 'FocusSiteCallLite-main', plugins_url( '/css/main.css', __FILE__ ) );
        wp_enqueue_style( 'FocusSiteCallLite-main' );
    }
}

if ( is_admin() ) {
	$focus_sitecall = new FocusSitecallLite();
}

$provider = new FocusSitecallLite_Provider();